Index: branches/HTM-14.1-update-dev0/source/Lib/TLibDecoder/TDecTop.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibDecoder/TDecTop.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibDecoder/TDecTop.h	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -44,4 +44,5 @@
 #include "TLibCommon/TComPic.h"
 #include "TLibCommon/TComTrQuant.h"
+#include "TLibCommon/TComPrediction.h"
 #include "TLibCommon/SEI.h"
 
@@ -52,5 +53,5 @@
 #include "SEIread.h"
 
-struct InputNALUnit;
+class InputNALUnit;
 
 //! \ingroup TLibDecoder
@@ -61,8 +62,8 @@
 // ====================================================================================================================
 
-#if H_MV
+#if NH_MV
 class TAppDecTop;
 #endif
-#if H_3D
+#if NH_3D
 class CamParsCollector
 {
@@ -71,5 +72,6 @@
   ~CamParsCollector ();
 
-  Void  init        ( FILE* pCodedScaleOffsetFile, TComVPS* vps );
+  Void  init        ( const TComVPS* vps );
+  Void  setCodeScaleOffsetFile( FILE* pCodedScaleOffsetFile ) { m_pCodedScaleOffsetFile = pCodedScaleOffsetFile; };     
 
   Void  uninit      ();
@@ -95,5 +97,5 @@
   Int**   m_aaiCodedScale;
   
-  TComVPS* m_vps; 
+  const TComVPS* m_vps; 
   Int**    m_receivedIdc; 
   Int      m_lastPoc; 
@@ -180,5 +182,5 @@
 private:
   Int                     m_iMaxRefPicNum;
-  
+
   NalUnitType             m_associatedIRAPType; ///< NAL unit type of the associated IRAP picture
   Int                     m_pocCRA;            ///< POC number of the latest CRA picture
@@ -186,14 +188,14 @@
 
   TComList<TComPic*>      m_cListPic;         //  Dynamic buffer
-#if H_MV
+#if NH_MV
   Bool*                    m_layerInitilizedFlag; // initialization Layers
-  static ParameterSetManagerDecoder m_parameterSetManagerDecoder;  // storage for parameter sets 
-  Int                      m_targetOptLayerSetIdx; 
+  static ParameterSetManager m_parameterSetManager;  // storage for parameter sets 
+  Int                      m_targetOlsIdx; 
 #else
-  ParameterSetManagerDecoder m_parameterSetManagerDecoder;  // storage for parameter sets 
+  ParameterSetManager     m_parameterSetManager;  // storage for parameter sets
 #endif
   TComSlice*              m_apcSlicePilot;
-  
-  SEIMessages             m_SEIs; ///< List of SEI messages that have been received before the first slice and between slices
+
+  SEIMessages             m_SEIs; ///< List of SEI messages that have been received before the first slice and between slices, excluding prefix SEIs...
 
   // functional classes
@@ -212,24 +214,33 @@
 
   Bool isSkipPictureForBLA(Int& iPOCLastDisplay);
+#if NH_MV
+  Bool isRandomAccessSkipPicture(Int& iSkipFrame,  Int& iPOCLastDisplay, const TComVPS* vps);
+#else
   Bool isRandomAccessSkipPicture(Int& iSkipFrame,  Int& iPOCLastDisplay);
+#endif
   TComPic*                m_pcPic;
   UInt                    m_uiSliceIdx;
   Int                     m_prevPOC;
+  Int                     m_prevTid0POC;
   Bool                    m_bFirstSliceInPicture;
   Bool                    m_bFirstSliceInSequence;
   Bool                    m_prevSliceSkipped;
   Int                     m_skippedPOC;
-#if SETTING_NO_OUT_PIC_PRIOR  
   Bool                    m_bFirstSliceInBitstream;
   Int                     m_lastPOCNoOutputPriorPics;
   Bool                    m_isNoOutputPriorPics;
   Bool                    m_craNoRaslOutputFlag;    //value of variable NoRaslOutputFlag of the last CRA pic
-#endif
-#if H_MV
+#if O0043_BEST_EFFORT_DECODING
+  UInt                    m_forceDecodeBitDepth;
+#endif
+  std::ostream           *m_pDecodedSEIOutputStream;
+
+  Bool                    m_warningMessageSkipPicture;
+#if NH_MV
   Bool                    m_isLastNALWasEos;
 #endif
 
-#if H_MV
-  // For H_MV m_bFirstSliceInSequence indicates first slice in sequence of the particular layer  
+#if NH_MV
+  // For NH_MV m_bFirstSliceInSequence indicates first slice in sequence of the particular layer  
   Int                     m_layerId;
   Int                     m_viewId;
@@ -237,5 +248,5 @@
   std::vector<TComPic*>   m_refPicSetInterLayer0; 
   std::vector<TComPic*>   m_refPicSetInterLayer1; 
-#if H_3D
+#if NH_3D
   Int                     m_viewIndex; 
   Bool                    m_isDepth;
@@ -245,15 +256,16 @@
 #endif
 
+  std::list<InputNALUnit*> m_prefixSEINALUs; /// Buffered up prefix SEI NAL Units.
 public:
   TDecTop();
   virtual ~TDecTop();
-  
+
   Void  create  ();
   Void  destroy ();
 
-  void setDecodedPictureHashSEIEnabled(Int enabled) { m_cGopDecoder.setDecodedPictureHashSEIEnabled(enabled); }
+  Void setDecodedPictureHashSEIEnabled(Int enabled) { m_cGopDecoder.setDecodedPictureHashSEIEnabled(enabled); }
 
   Void  init();
-#if H_MV  
+#if NH_MV  
   Bool  decode(InputNALUnit& nalu, Int& iSkipFrame, Int& iPOCLastDisplay, Bool newLayer, Bool& sliceSkippedFlag );
   Bool  decode(InputNALUnit& nalu, Int& iSkipFrame, Int& iPOCLastDisplay, Bool newLayer );
@@ -261,32 +273,35 @@
   Bool  decode(InputNALUnit& nalu, Int& iSkipFrame, Int& iPOCLastDisplay);
 #endif
-  
   Void  deletePicBuffer();
-#if H_MV
-  TComVPS* getActiveVPS() { return m_parameterSetManagerDecoder.getActiveVPS( ); }
-  TComSPS* getActiveSPS() { return m_parameterSetManagerDecoder.getActiveSPS( m_layerId ); }
-#else
-  TComSPS* getActiveSPS() { return m_parameterSetManagerDecoder.getActiveSPS(); }
-#endif
-
-#if H_MV
+
+#if NH_MV
+  const TComVPS* getActiveVPS() { return m_parameterSetManager.getActiveVPS( ); }
+  const TComSPS* getActiveSPS() { return m_parameterSetManager.getActiveSPS( m_layerId ); }
+#endif
+
+#if NH_MV
   Void endPicDecoding(Int& poc, TComList<TComPic*>*& rpcListPic,  std::vector<Int>& targetDecLayerIdSet);  
-#else
-  Void executeLoopFilters(Int& poc, TComList<TComPic*>*& rpcListPic);
-#endif
-  
-#if SETTING_NO_OUT_PIC_PRIOR  
-  Void  checkNoOutputPriorPics (TComList<TComPic*>*& rpcListPic);
+#else  
+  Void  executeLoopFilters(Int& poc, TComList<TComPic*>*& rpcListPic);
+#endif
+  Void  checkNoOutputPriorPics (TComList<TComPic*>* rpcListPic);
 
   Bool  getNoOutputPriorPicsFlag () { return m_isNoOutputPriorPics; }
-  Void  setNoOutputPriorPicsFlag (bool val) { m_isNoOutputPriorPics = val; }
-#endif
-#if H_MV    
+  Void  setNoOutputPriorPicsFlag (Bool val) { m_isNoOutputPriorPics = val; }
+  Void  setFirstSliceInPicture (bool val)  { m_bFirstSliceInPicture = val; }
+  Bool  getFirstSliceInSequence ()         { return m_bFirstSliceInSequence; }
+  Void  setFirstSliceInSequence (bool val) { m_bFirstSliceInSequence = val; }
+#if O0043_BEST_EFFORT_DECODING
+  Void  setForceDecodeBitDepth(UInt bitDepth) { m_forceDecodeBitDepth = bitDepth; }
+#endif
+  Void  setDecodedSEIMessageOutputStream(std::ostream *pOpStream) { m_pDecodedSEIOutputStream = pOpStream; }
+  UInt  getNumberOfChecksumErrorsDetected() const { return m_cGopDecoder.getNumberOfChecksumErrorsDetected(); }
+#if NH_MV    
   TComPic*                getPic                ( Int poc );
   TComList<TComPic*>*     getListPic            ()               { return &m_cListPic;  }  
   Void                    setIvPicLists         ( TComPicLists* picLists) { m_ivPicLists = picLists; }
   Void                    setLayerInitilizedFlags( Bool* val )    { m_layerInitilizedFlag = val; }
-  Void                    setTargetOptLayerSetIdx( Int targetOptLayerSetIdx ) { m_targetOptLayerSetIdx = targetOptLayerSetIdx; }    
-  TComVPS*                getPrefetchedVPS      ()               { return m_parameterSetManagerDecoder.getPrefetchedVPS( 0 ); }; //Assuming that currently only one VPS is present. 
+  Void                    setTargetOlsIdx       ( Int targetOlsIdx ) { m_targetOlsIdx = targetOlsIdx; }    
+  Int                     getTargetOlsIdx       ( )                  { return m_targetOlsIdx; }    
   Int                     getCurrPoc            ()               { return m_apcSlicePilot->getPOC(); }
   Void                    setLayerId            ( Int layer)     { m_layerId = layer;   }
@@ -294,5 +309,6 @@
   Void                    setViewId             ( Int viewId  )  { m_viewId  = viewId;  }
   Int                     getViewId             ()               { return m_viewId;     }  
-#if H_3D    
+  Void                    initFromActiveVps     ( const TComVPS* vps );
+#if NH_3D    
   Void                    setViewIndex          ( Int viewIndex  )  { m_viewIndex  = viewIndex;  }
   Int                     getViewIndex          ()               { return m_viewIndex;     }  
@@ -301,14 +317,15 @@
   Void                    setCamParsCollector( CamParsCollector* pcCamParsCollector ) { m_pcCamParsCollector = pcCamParsCollector; }
 
-  Void                    setProfileIdc();
+
   Bool                    decProcAnnexI()           { assert( m_profileIdc != -1 ); return ( m_profileIdc == 8); }    
 #endif
 #endif
+
 protected:
-  Void  xGetNewPicBuffer  (TComSlice* pcSlice, TComPic*& rpcPic);
+  Void  xGetNewPicBuffer  (const TComSPS &sps, const TComPPS &pps, TComPic*& rpcPic, const UInt temporalLayer);
   Void  xCreateLostPicture (Int iLostPOC);
 
   Void      xActivateParameterSets();
-#if H_MV  
+#if NH_MV  
   TComPic*  xGetPic( Int layerId, Int poc ); 
   Bool      xDecodeSlice(InputNALUnit &nalu, Int &iSkipFrame, Int iPOCLastDisplay, Bool newLayerFlag, Bool& sliceSkippedFlag );  
@@ -316,12 +333,15 @@
   Void      xCeckNoClrasOutput();
 
-  Bool      xAllRefLayersInitilized();
+  Bool      xAllRefLayersInitilized( const TComVPS* vps );
 #else
   Bool      xDecodeSlice(InputNALUnit &nalu, Int &iSkipFrame, Int iPOCLastDisplay);
 #endif
-  Void      xDecodeVPS();
-  Void      xDecodeSPS();
-  Void      xDecodePPS();
-  Void      xDecodeSEI( TComInputBitstream* bs, const NalUnitType nalUnitType );
+  Void      xDecodeVPS(const std::vector<UChar> &naluData);
+  Void      xDecodeSPS(const std::vector<UChar> &naluData);
+  Void      xDecodePPS(const std::vector<UChar> &naluData);
+  Void      xUpdatePreviousTid0POC( TComSlice *pSlice ) { if ((pSlice->getTLayer()==0) && (pSlice->isReferenceNalu() && (pSlice->getNalUnitType()!=NAL_UNIT_CODED_SLICE_RASL_R)&& (pSlice->getNalUnitType()!=NAL_UNIT_CODED_SLICE_RADL_R))) { m_prevTid0POC=pSlice->getPOC(); } }
+
+  Void      xParsePrefixSEImessages();
+  Void      xParsePrefixSEIsForUnknownVCLNal();
 
 };// END CLASS DEFINITION TDecTop
Index: branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/AnnexBwrite.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/AnnexBwrite.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/AnnexBwrite.h	(revision 1200)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -33,4 +33,7 @@
 
 #pragma once
+
+#ifndef __ANNEXBWRITE__
+#define __ANNEXBWRITE__
 
 #include <ostream>
@@ -85,2 +88,4 @@
 }
 //! \}
+
+#endif
Index: branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/NALwrite.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/NALwrite.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/NALwrite.cpp	(revision 1200)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -53,8 +53,8 @@
   bsNALUHeader.write(0,1);                    // forbidden_zero_bit
   bsNALUHeader.write(nalu.m_nalUnitType, 6);  // nal_unit_type
-#if H_MV
-  bsNALUHeader.write(nalu.m_layerId, 6);      // layerId       
+#if NH_MV
+  bsNALUHeader.write(nalu.m_nuhLayerId, 6);      // layerId       
 #else
-  bsNALUHeader.write(nalu.m_reservedZero6Bits, 6);                   // nuh_reserved_zero_6bits
+  bsNALUHeader.write(nalu.m_nuhLayerId, 6);   // nuh_layer_id
 #endif
   bsNALUHeader.write(nalu.m_temporalId+1, 3); // nuh_temporal_id_plus1
@@ -66,5 +66,5 @@
  * emulation as required.  nalu.m_RBSPayload must be byte aligned.
  */
-void write(ostream& out, OutputNALUnit& nalu)
+Void write(ostream& out, OutputNALUnit& nalu)
 {
   writeNalUnitHeader(out, nalu);
@@ -91,37 +91,27 @@
   vector<uint8_t>& rbsp   = nalu.m_Bitstream.getFIFO();
 
-  if (rbsp.size() == 0)
+  vector<uint8_t> outputBuffer;
+  outputBuffer.resize(rbsp.size()*2+1); //there can never be enough emulation_prevention_three_bytes to require this much space
+  std::size_t outputAmount = 0;
+  Int         zeroCount    = 0;
+  for (vector<uint8_t>::iterator it = rbsp.begin(); it != rbsp.end(); it++)
   {
-    return;
+    const uint8_t v=(*it);
+    if (zeroCount==2 && v<=3)
+    {
+      outputBuffer[outputAmount++]=emulation_prevention_three_byte[0];
+      zeroCount=0;
+    }
+
+    if (v==0)
+    {
+      zeroCount++;
+    }
+    else
+    {
+      zeroCount=0;
+    }
+    outputBuffer[outputAmount++]=v;
   }
-
-  for (vector<uint8_t>::iterator it = rbsp.begin(); it != rbsp.end();)
-  {
-    /* 1) find the next emulated 00 00 {00,01,02,03}
-     * 2a) if not found, write all remaining bytes out, stop.
-     * 2b) otherwise, write all non-emulated bytes out
-     * 3) insert emulation_prevention_three_byte
-     */
-    vector<uint8_t>::iterator found = it;
-    do
-    {
-      /* NB, end()-1, prevents finding a trailing two byte sequence */
-      found = search_n(found, rbsp.end()-1, 2, 0);
-      found++;
-      /* if not found, found == end, otherwise found = second zero byte */
-      if (found == rbsp.end())
-        break;
-      if (*(++found) <= 3)
-        break;
-    } while (true);
-
-    it = found;
-    if (found != rbsp.end())
-    {
-      it = rbsp.insert(found, emulation_prevention_three_byte[0]);
-    }
-  }
-
-  out.write((Char*)&(*rbsp.begin()), rbsp.end() - rbsp.begin());
 
   /* 7.4.1.1
@@ -130,32 +120,9 @@
    * to 0x03 is appended to the end of the data.
    */
-  if (rbsp.back() == 0x00)
+  if (zeroCount>0)
   {
-    out.write(emulation_prevention_three_byte, 1);
+    outputBuffer[outputAmount++]=emulation_prevention_three_byte[0];
   }
-}
-
-/**
- * Write rbsp_trailing_bits to bs causing it to become byte-aligned
- */
-void writeRBSPTrailingBits(TComOutputBitstream& bs)
-{
-  bs.write( 1, 1 );
-  bs.writeAlignZero();
-}
-
-/**
- * Copy NALU from naluSrc to naluDest
- */
-void copyNaluData(OutputNALUnit& naluDest, const OutputNALUnit& naluSrc)
-{
-  naluDest.m_nalUnitType = naluSrc.m_nalUnitType;
-#if H_MV
-  naluDest.m_layerId  = naluSrc.m_layerId;
-#else
-  naluDest.m_reservedZero6Bits  = naluSrc.m_reservedZero6Bits;
-#endif
-  naluDest.m_temporalId  = naluSrc.m_temporalId;
-  naluDest.m_Bitstream   = naluSrc.m_Bitstream;
+  out.write((Char*)&(*outputBuffer.begin()), outputAmount);
 }
 
Index: branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/NALwrite.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/NALwrite.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/NALwrite.h	(revision 1200)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -34,7 +34,10 @@
 #pragma once
 
+#ifndef __NALWRITE__
+#define __NALWRITE__
+
 #include <ostream>
 
-#include "TLibCommon/TypeDef.h"
+#include "TLibCommon/CommonDef.h"
 #include "TLibCommon/TComBitStream.h"
 #include "TLibCommon/NAL.h"
@@ -57,10 +60,10 @@
     NalUnitType nalUnitType,
     UInt temporalID = 0,
-#if H_MV
+#if NH_MV
     Int layerId = 0)
 #else
     UInt reserved_zero_6bits = 0)
 #endif
-#if H_MV
+#if NH_MV
   : NALUnit(nalUnitType, temporalID, layerId)
 #else
@@ -80,6 +83,5 @@
 };
 
-void write(std::ostream& out, OutputNALUnit& nalu);
-void writeRBSPTrailingBits(TComOutputBitstream& bs);
+Void write(std::ostream& out, OutputNALUnit& nalu);
 
 inline NALUnitEBSP::NALUnitEBSP(OutputNALUnit& nalu)
@@ -89,5 +91,5 @@
 }
 
-void copyNaluData(OutputNALUnit& naluDest, const OutputNALUnit& naluSrc);
+//! \}
 
-//! \}
+#endif
